## List external storage configurations

**get** `/organization/external_storage`

List the organization's customer-managed external storage configurations.

### Query Parameters

- `after: optional string or null`

  Return external storage configurations after this ID.

- `limit: optional integer`

  `minimum: 1`, `maximum: 100`

- `order: optional "asc" or "desc"`

  - `"asc"`

  - `"desc"`

- `project_id: optional string or null`

### Returns

- `data: array of ExternalStorageConfiguration`

  - `id: string`

  - `created_at: integer`

    `format: unixtime`

  - `geography: string`

  - `object: "organization.external_storage" (default: "organization.external_storage")`

    - `"organization.external_storage"`

  - `project_id: string`

  - `provider: AwsExternalStorageProvider or AzureExternalStorageProvider or GcpExternalStorageProvider or OciExternalStorageProvider`

    - `AwsExternalStorageProvider object { account_id, bucket, external_id, 3 more }`

      - `account_id: string`

      - `bucket: string`

      - `external_id: string`

      - `region: string`

      - `role_arn: string`

      - `type: "aws" (default: "aws")`

        - `"aws"`

    - `AzureExternalStorageProvider object { account_name, container, region, 4 more }`

      - `account_name: string`

      - `container: string`

      - `region: string`

      - `resource_group: string`

      - `subscription_id: string`

      - `tenant_id: string`

      - `type: "azure" (default: "azure")`

        - `"azure"`

    - `GcpExternalStorageProvider object { audience, bucket, region, 4 more }`

      - `audience: string`

      - `bucket: string`

      - `region: string`

      - `type: "gcp" (default: "gcp")`

        - `"gcp"`

      - `workload_identity_pool_id: string`

      - `workload_identity_project_number: string`

      - `workload_identity_provider_id: string`

    - `OciExternalStorageProvider object { bucket, region, tenancy_ocid, type }`

      - `bucket: string`

      - `region: string`

      - `tenancy_ocid: string`

      - `type: "oci" (default: "oci")`

        - `"oci"`

  - `status: "pending" or "validated" or "degraded" or "unhealthy"`

    - `"pending"`

    - `"validated"`

    - `"degraded"`

    - `"unhealthy"`

- `first_id: string or null`

- `has_more: boolean`

- `last_id: string or null`

- `object: "list" (default: "list")`

  - `"list"`

### Example

```http
curl https://api.openai.com/v1/organization/external_storage \
    -H "Authorization: Bearer $OPENAI_ADMIN_KEY"
```

#### 200 — Example

```json
{
  "data": [
    {
      "id": "id",
      "created_at": 0,
      "geography": "geography",
      "object": "organization.external_storage",
      "project_id": "project_id",
      "provider": {
        "account_id": "account_id",
        "bucket": "bucket",
        "external_id": "external_id",
        "region": "region",
        "role_arn": "role_arn",
        "type": "aws"
      },
      "status": "pending"
    }
  ],
  "first_id": "first_id",
  "has_more": true,
  "last_id": "last_id",
  "object": "list"
}
```

### Example

```http
curl "https://api.openai.com/v1/organization/external_storage?limit=20&order=desc" \
  -H "Authorization: Bearer $OPENAI_ADMIN_KEY" \
  -H "Content-Type: application/json"
```

#### Response example

```json
{
  "object": "list",
  "data": [
    {
      "object": "organization.external_storage",
      "id": "extstorage_abc123",
      "project_id": "proj_abc123",
      "provider": {
        "type": "aws",
        "account_id": "123456789012",
        "region": "us-east-1",
        "bucket": "customer-logs",
        "role_arn": "arn:aws:iam::123456789012:role/OpenAIExternalStorageRole",
        "external_id": "proj_abc123"
      },
      "geography": "US",
      "status": "validated",
      "created_at": 1711471533
    },
    {
      "object": "organization.external_storage",
      "id": "extstorage_azure123",
      "project_id": "proj_azure123",
      "provider": {
        "type": "azure",
        "tenant_id": "11111111-1111-1111-1111-111111111111",
        "subscription_id": "22222222-2222-2222-2222-222222222222",
        "resource_group": "customer-rg",
        "account_name": "customerstorage",
        "container": "openai-data",
        "region": "eastus"
      },
      "geography": "US",
      "status": "validated",
      "created_at": 1711471500
    },
    {
      "object": "organization.external_storage",
      "id": "extstorage_gcp123",
      "project_id": "proj_gcp123",
      "provider": {
        "type": "gcp",
        "bucket": "customer-gcp-retention",
        "workload_identity_project_number": "123456789012",
        "workload_identity_pool_id": "customer-pool",
        "workload_identity_provider_id": "customer-provider",
        "region": "us-central1",
        "audience": "proj_gcp123"
      },
      "geography": "US",
      "status": "validated",
      "created_at": 1711471400
    },
    {
      "object": "organization.external_storage",
      "id": "extstorage_oci123",
      "project_id": "proj_oci123",
      "provider": {
        "type": "oci",
        "tenancy_ocid": "ocid1.tenancy.oc1..example",
        "region": "us-ashburn-1",
        "bucket": "customer-oci-retention"
      },
      "geography": "US",
      "status": "validated",
      "created_at": 1711471300
    }
  ],
  "first_id": "extstorage_abc123",
  "last_id": "extstorage_oci123",
  "has_more": false
}
```
